#ifndef M2IF_MATRIX_H
#define M2IF_MATRIX_H

#include <ostream>

namespace m2if {

class Matrix
{
 protected:
  int nr_; // #rows
  int nc_; // #columns
  double ** data_;

 public: // structors
  Matrix(int nl, int nc);
  Matrix(const Matrix & m);
  ~Matrix();

 public: // getters / setters
  int get_nr() { return nr_; }
  int get_nc() { return nc_; }
  int get_nr() const { return nr_; }
  int get_nc() const { return nc_; }
  double & operator()(int r, int c);
  double operator()(int r, int c) const;

 public: // operators
  Matrix & operator=(const Matrix & m);
  friend std::ostream & operator<<(std::ostream & st, const Matrix & m);

  friend Matrix operator+(const Matrix & m1, const Matrix & m2);
  friend Matrix operator-(const Matrix & m1, const Matrix & m2);
  friend Matrix operator*(const Matrix & m1, const Matrix & m2);
  friend Matrix operator*(const Matrix & m, const double & v);
  friend Matrix operator*(const double & v, const Matrix & m);

 public:
  double trace();
  double det();
};

} // namespace m2if

#endif // M2IF_MATRIX_H
