#ifndef M2IF_VECTOR_H
#define M2IF_VECTOR_H

#include "matrix.h"

namespace m2if {

class Vector : public Matrix
{
 public: // structors;
  Vector(int dim);
  Vector(const Vector & v);

 public: // getters / setters
  int get_dim() { return get_nr(); }
  int get_dim() const { return get_nr(); }
  double & operator[](int i);
  double operator[](int i) const;

 public: // operators

  friend Vector operator+(const Vector & v1, const Vector & v2);
  friend Vector operator-(const Vector & v1, const Vector & v2);
  friend double operator*(const Vector & v1, const Vector & v2);
  friend Vector operator*(const Matrix & m, const Vector & v);

  private: // private methods
  void copy_data(const Matrix & m);
};

} // namespace m2if

#endif // M2IF_VECTOR_H
